<template>
  <CForm
    class="user-search-form"
    @submit.prevent="onSubmit"
  >
    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="name"
          label="Thing name"
          placeholder="Enter Things name"
          horizontal
          type="text"
          :disabled="loading"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'lightbulb']" class="width-1x" />
          </template>
        </CInput>
      </div>

      <div class="col-12 col-xl-6">
        <div role="group" class="form-group form-row">
          <CCol tag="label" sm="3" class="col-form-label">
            Status
          </CCol>
          <CCol sm="9" class="form-inline">
            <app-radio-group v-model="status" :list="[]" :name="'status'" />
          </CCol>
        </div>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="zoneName"
          label="Zone name"
          placeholder="Enter Zones name"
          horizontal
          type="text"
          :disabled="loading"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'th']" class="width-1x" />
          </template>
        </CInput>
      </div>

      <div class="col-12 col-xl-6">
        <CInput
          v-model="groupName"
          label="Group name"
          placeholder="Enter Groups name"
          horizontal
          type="text"
          :disabled="loading"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'sitemap']" class="width-1x" />
          </template>
        </CInput>
      </div>
    </div>

    <div class="row">
      <div class="col-12 col-xl-6">
        <CInput
          v-model="macAdress"
          label="Mac Address"
          placeholder="xx : xx : xx : xx : xx : xx"
          horizontal
          type="text"
          :disabled="loading"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'grip-vertical']" class="width-1x" />
          </template>
        </CInput>
      </div>

      <div class="col-12 col-xl-6">
        <CInput
          v-model="ipAdress"
          label="IP Address"
          placeholder="xxx . xxx . xxx . xxx "
          horizontal
          type="text"
          :disabled="loading"
        >
          <template #prepend-content>
            <font-awesome-icon :icon="['fas', 'code']" class="width-1x" />
          </template>
        </CInput>
      </div>
    </div>

    <div class="box-form-footer form-group">
      <CButton
        type="submit"
        color="primary"
        :disabled="disabled || loading"
      >
        <font-awesome-icon :icon="['fas', 'search']" class="width-1x" />
        Search
      </CButton>
      &nbsp;
      <CButton
        color="secondary"
        :disabled="loading"
        @click="onClearFormSearch"
      >
        <font-awesome-icon :icon="['fas', 'eraser']" class="width-1x" />
        Clear
      </CButton>
    </div>
  </CForm>
</template>

<style lang="scss" scoped>
  /* -----------------------------------------------------------
    user-search-form
    ----------------------------------------------------------- */
  .user-search-form {
    /deep/ {
      .col-form-label {
        text-align: right;
        @include mq(max_lg) {
          text-align: left;
        }
      }
      .box-form-footer {
        text-align: center;
        .btn {
          min-width: 100px;
        }
      }
    }
  }
</style>
<script>
import { isEqual } from 'lodash'
import AppRadioGroup from '~/components/atoms/AppRadioGroup'

const EVENT_SUBMIT = 'submit'

export default {
  components: {
    AppRadioGroup
  },

  props: {
    /**
     * Default condition
     */
    defaultCondition: {
      type: Object,
      default: () => {}
    },

    /**
     * Loading status
     */
    loading: {
      type: Boolean,
      default: false
    }
  },

  data () {
    return {
      // Form search
      name: '',
      status: null,
      groupName: '',
      zoneName: '',
      macAdress: '',
      ipAdress: '',

      // Previous codition
      prevCondition: null
    }
  },

  computed: {
    /**
     * Check disable button search.
     */
    disabled () {
      if (this.prevCondition === null) {
        return false
      }
      return isEqual(this.prevCondition, this.condition)
    },

    /**
     * Get condition input on form
     */
    condition () {
      const condition = {}

      if (this.name) {
        condition.name = this.name
      }

      if (this.status === 1 || this.status === 0) {
        condition.status = this.status
      }

      if (this.groupName) {
        condition.groupName = this.groupName
      }

      if (this.zoneName) {
        condition.zoneName = this.zoneName
      }

      if (this.macAdress) {
        condition.mac_address = this.macAdress
      }

      if (this.ipAdress) {
        condition.ip_address = this.ipAdress
      }

      return condition
    }
  },

  methods: {
    /**
     * Clear form search
     *
     */
    onClearFormSearch () {
      this.name = ''
      this.status = null
      this.groupName = ''
      this.zoneName = ''
      this.macAdress = ''
      this.ipAdress = ''
    },

    /**
     * Check validate input
     * If valid then show error
     * Else call submit event of page index
     */
    onSubmit () {
      this.prevCondition = this.condition
      this.$emit(EVENT_SUBMIT, this.condition)
    }

  }
}
</script>
